--- a/drivers/scsi/libata-core.c
+++ b/drivers/scsi/libata-core.c
@@ -4297,6 +4297,7 @@ static int ata_start_drive(struct ata_po
 int ata_device_resume(struct ata_port *ap, struct ata_device *dev)
 {
	if (ap->flags & ATA_FLAG_SUSPENDED) {
+		ata_busy_sleep(ap, ATA_TMOUT_BOOT_QUICK, ATA_TMOUT_BOOT);
		ata_busy_wait(ap, ATA_BUSY | ATA_DRQ, 200000);
		ap->flags &= ~ATA_FLAG_SUSPENDED;
		ata_set_mode(ap);
